// Auto-Lib.h
// ,   , 
//        ,
//  ,      
//  

#ifndef __Auto_Lib_h
#define __Auto_Lib_h

#include <stdio.h>
#include "xString.h"
#include "xTypes.h"

//  ""
class BaseAutomat;

//    ""
class BaseState
{

public:

	uint32 y;	// 

	//
	BaseState(uint32 y)
	{
		this->y=y;
	}
	
	// 
	BaseState(BaseState &Y)
	{
		this->y=Y.y;
	}
	
	//
	virtual ~BaseState()
	{

	}
};

//    ""
class BaseEvent
{
	
public:

  uint32 e;	// 

	//
	BaseEvent(uint32 e)
	{
		this->e=e;
	}
	
	//
	virtual ~BaseEvent()
	{

	}
};

//    " "
class BaseParam
{
	
public:

  uint32 x;	//  

	//
	BaseParam(uint32 x)
	{
		this->x=x;
	}
	
	//
	virtual ~BaseParam()
	{

	}
};

//    " "
class BaseAction
{
	
public:

  uint32 z;	//  

	//
	BaseAction(uint32 z)
	{
		this->z=z;
	}
	
	//
	virtual ~BaseAction()
	{

	}
};

//  ""
class BaseAutomat
{
	
public:

	BaseState *Y;	//  ()
	uint32 y;		//  ()
	
	BaseEvent *E;	//    ()
	uint32 e;		//    ()

	uint32 a;		// 

	BaseState **RegisteredStates;	// 
	uint32 iRegisteredStatesNum;	//  

	BaseEvent **RegisteredEvents;	// 
	uint32 iRegisteredEventsNum;	//  

	BaseParam **RegisteredParams;	//  
	uint32 iRegisteredParamsNum;	//   

	BaseAction **RegisteredActions;	//  
	uint32 iRegisteredActionsNum;	//   
	
	//
	BaseAutomat(uint32 a)
	{
		this->Y=NULL;
		this->y=-1;
		this->a=a;
		iRegisteredStatesNum=0;
		iRegisteredEventsNum=0;
		iRegisteredParamsNum=0;
		iRegisteredActionsNum=0;
		RegisteredStates=new BaseState*[iRegisteredStatesNum];
		RegisteredEvents=new BaseEvent*[iRegisteredEventsNum];
		RegisteredParams=new BaseParam*[iRegisteredParamsNum];
		RegisteredActions=new BaseAction*[iRegisteredActionsNum];
	}
	
	//
	virtual ~BaseAutomat()
	{
		uint32 i;
		
		for(i=0;i<iRegisteredStatesNum;i++)
		{
			delete RegisteredStates[i];
		}
		delete[] RegisteredStates;
		
		for(i=0;i<iRegisteredEventsNum;i++)
		{
			delete RegisteredEvents[i];
		}
		delete[] RegisteredEvents;
		
		for(i=0;i<iRegisteredParamsNum;i++)
		{
			delete RegisteredParams[i];
		}
		delete[] RegisteredParams;
		
		for(i=0;i<iRegisteredActionsNum;i++)
		{
			delete RegisteredActions[i];
		}
		delete[] RegisteredActions;
	}
	
	//   
	uint32 Get_y()
	{
		return Y->y;
	}
	
	// 
	virtual BaseState *RegisterState(uint32 y)
	{
		BaseState *Y=new BaseState(y);
		AddState(Y);
		return Y;
	}
	
	//    
	void AddState(BaseState *Y)
	{
		BaseState **NewRegisteredStates=new BaseState*[iRegisteredStatesNum+1];
		for(uint32 i=0;i<iRegisteredStatesNum;i++)
		{
			NewRegisteredStates[i]=RegisteredStates[i];
		}
		delete[] RegisteredStates;	
		NewRegisteredStates[iRegisteredStatesNum]=Y;
		RegisteredStates=NewRegisteredStates;
		iRegisteredStatesNum++;
	}
	
	//c 
	virtual BaseEvent *RegisterEvent(uint32 e)
	{
		BaseEvent *E=new BaseEvent(e);
		AddEvent(E);
		return E;
	}
	
	//    
	void AddEvent(BaseEvent *E)
	{
		BaseEvent **NewRegisteredEvents=new BaseEvent*[iRegisteredEventsNum+1];
		for(uint32 i=0;i<iRegisteredEventsNum;i++)
		{
			NewRegisteredEvents[i]=RegisteredEvents[i];
		}
		delete[] RegisteredEvents;	
		NewRegisteredEvents[iRegisteredEventsNum]=E;
		RegisteredEvents=NewRegisteredEvents;
		iRegisteredEventsNum++;
	}
	
	//c  
	virtual BaseParam *RegisterParam(uint32 x)
	{
		BaseParam *X=new BaseParam(x);
		AddParam(X);
		return X;
	}
	
	//      
	void AddParam(BaseParam *X)
	{
		BaseParam **NewRegisteredParams=new BaseParam*[iRegisteredParamsNum+1];
		for(uint32 i=0;i<iRegisteredParamsNum;i++)
		{
			NewRegisteredParams[i]=RegisteredParams[i];
		}
		delete[] RegisteredParams;	
		NewRegisteredParams[iRegisteredParamsNum]=X;
		RegisteredParams=NewRegisteredParams;
		iRegisteredParamsNum++;
	}
	
	//c  
	virtual BaseAction *RegisterAction(uint32 z)
	{
		BaseAction *Z=new BaseAction(z);
		AddAction(Z);
		return Z;
	}
	
	//     
	void AddAction(BaseAction *Z)
	{
		BaseAction **NewRegisteredActions=new BaseAction*[iRegisteredActionsNum+1];
		for(uint32 i=0;i<iRegisteredActionsNum;i++)
		{
			NewRegisteredActions[i]=RegisteredActions[i];
		}
		delete[] RegisteredActions;	
		NewRegisteredActions[iRegisteredActionsNum]=Z;
		RegisteredActions=NewRegisteredActions;
		iRegisteredActionsNum++;
	}

	//  (  )
	void virtual Main()
	{

	}
	
	//   - (    )
	void BaseRun(BaseEvent *E)
	{
		this->E=E;
	    this->e=E->e;
		this->y=Y->y;
		uint32 old_y=y;
		BaseState *Old_Y=Y;
		Main();
		if (y!=old_y)
		{
			for(uint32 i=0;i<iRegisteredStatesNum;i++)
			{
				if (RegisteredStates[i]->y==y)
				{
					Y=RegisteredStates[i];
					return;
				}
			}
			throw "    -";
		} else
		{
			y=Y->y;
		}

	}
	
	//   - (   )
	void virtual Run(BaseEvent *E)
	{
		BaseRun(E);
	}
	
	//   -
	void virtual run(uint32 e)
	{
		for(uint32 i=0;i<iRegisteredEventsNum;i++)
		{
			if (RegisteredEvents[i]->e==e)
			{
				Run(RegisteredEvents[i]);
				return;
			}
		}
		throw "      ";
	}

	//  n-  
	virtual bool x(uint32 n)
	{
		return Param(n);
	}

	//  n-  
	virtual bool Param(uint32 n)
	{
		return false;
	}

	// n-  
	virtual void z(uint32 n)
	{
		Action(n);
	}

	// n-  
	virtual void Action(uint32 n)
	{

	}
};

//    "  "
class DescriptedState : public BaseState
{
	
public:

  xstring szStateDescription;	// 
	
	//
	DescriptedState(uint32 y,xstring szStateDescription) : BaseState(y)
	{
		this->szStateDescription=szStateDescription;
	}

	// 
	DescriptedState(DescriptedState &Y) : BaseState(Y)
	{
		this->szStateDescription=Y.szStateDescription;
	}
	
	//
	virtual ~DescriptedState()
	{
		
	}
};

// "  "
class DescriptedEvent : public BaseEvent
{
	
public:

  xstring szEventDescription;	// 
	
	//
	DescriptedEvent(uint32 e,xstring szEventDescription) : BaseEvent(e)
	{
		this->szEventDescription=szEventDescription;
	}
	
	//
	virtual ~DescriptedEvent()
	{
		
	}
};

// "   "
class DescriptedParam : public BaseParam
{
	
public:

  xstring szParamDescription;	//  
	
	//
	DescriptedParam(uint32 x,xstring szParamDescription) : BaseParam(x)
	{
		this->szParamDescription=szParamDescription;
	}
	
	//
	virtual ~DescriptedParam()
	{
		
	}
};

// "   "
class DescriptedAction : public BaseAction
{
	
public:

  xstring szActionDescription;	//  
	
	//
	DescriptedAction(uint32 z,xstring szActionDescription) : BaseAction(z)
	{
		this->szActionDescription=szActionDescription;
	}
	
	//
	virtual ~DescriptedAction()
	{
		
	}
};

//    "  "
class DescriptedAutomat : public BaseAutomat
{

public:

  xstring szAutomatDescription;	// 
	
	//
	DescriptedAutomat(uint32 a, xstring szAutomatDescription) : BaseAutomat(a)
	{
		this->szAutomatDescription=szAutomatDescription;
	}
	
	//
	virtual ~DescriptedAutomat()
	{
		
	}

	//   
	virtual DescriptedState *RegisterState(uint32 y, xstring szStateDescription)
	{
		DescriptedState *Y=new DescriptedState(y,szStateDescription);
		AddState((BaseState*)Y);
		return Y;
	}
	
	//   
	virtual DescriptedEvent *RegisterEvent(uint32 e, xstring szEventDescription)
	{
		DescriptedEvent *E=new DescriptedEvent(e,szEventDescription);
		AddEvent((BaseEvent*)E);
		return E;
	}

	//    
	virtual DescriptedParam *RegisterParam(uint32 x, xstring szParamDescription)
	{
		DescriptedParam *X=new DescriptedParam(x,szParamDescription);
		AddParam((BaseParam*)X);
		return X;
	}
	
	//    
	virtual DescriptedAction *RegisterAction(uint32 z, xstring szActionDescription)
	{
		DescriptedAction *Z=new DescriptedAction(z,szActionDescription);
		AddAction((BaseAction*)Z);
		return Z;
	}
};

//    " "
class BaseLogger
{

public:
	
	//
	BaseLogger()
	{

	}

	//
	virtual ~BaseLogger()
	{
	
	}
	
	//  
	virtual LogAutomatCreated(DescriptedAutomat *A)
	{

	}

	//   
	virtual LogAutomatFinished(DescriptedAutomat *A)
	{

	}

	//  
	virtual LogStateRegistered(DescriptedAutomat *A,DescriptedState *Y)
	{

	}
	
	//  
	virtual LogEventRegistered(DescriptedAutomat *A,DescriptedEvent *Y)
	{

	}

	//   
	virtual LogParamRegistered(DescriptedAutomat *A,DescriptedParam *X)
	{

	}

	//   
	virtual LogActionRegistered(DescriptedAutomat *A,DescriptedAction *Z)
	{

	}
	
	//  
	virtual LogStateChanged(DescriptedAutomat *A, DescriptedState *Old_Y,DescriptedState *Y)
	{

	}
	
	//   
	virtual LogEventRaised(DescriptedAutomat *A,DescriptedEvent *E)
	{

	}
	
	//   
	virtual LogEventFinished(DescriptedAutomat *A,DescriptedEvent *E)
	{

	}

	//    
	virtual LogParamCalcStarted(DescriptedAutomat *A, DescriptedParam *X)
	{


	}

	//    
	virtual LogParamCalcFinished(DescriptedAutomat *A, DescriptedParam *X, bool x)
	{


	}

	//    
	virtual LogActionStarted(DescriptedAutomat *A, DescriptedAction *Z)
	{


	}

	//    
	virtual LogActionFinished(DescriptedAutomat *A, DescriptedAction *Z)
	{


	}

	//  
	virtual LogString(xstring szComment)
	{

	}

};

//    " "
class LoggedAutomat : public DescriptedAutomat
{

public:	

  BaseLogger *Logger;	// 

	//
	LoggedAutomat(uint32 a,xstring szAutomatDescription,BaseLogger *Logger) : DescriptedAutomat(a,szAutomatDescription)
	{
		this->Logger=Logger;
		if (Logger!=NULL)Logger->LogAutomatCreated(this);	
	}
	
	//
	~LoggedAutomat()
	{
		if (Logger!=NULL)Logger->LogAutomatFinished(this);
	}
	
	//  c     
	virtual DescriptedState* RegisterState(uint32 y,xstring szStateDescription)
	{
		DescriptedState *Y=new DescriptedState(y,szStateDescription);
		AddState((BaseState*)Y);
		if (Logger!=NULL)Logger->LogStateRegistered((DescriptedAutomat*)this,Y);
		return Y;
	}
	
	//       
	virtual DescriptedEvent* RegisterEvent(uint32 e,xstring szEventDescription)
	{
		DescriptedEvent *E=new DescriptedEvent(e,szEventDescription);
		AddEvent((BaseEvent*)E);
		if (Logger!=NULL)Logger->LogEventRegistered((DescriptedAutomat*)this,(DescriptedEvent*)E);
		return E;
	}

	//   c     
	virtual DescriptedParam* RegisterParam(uint32 x,xstring szParamDescription)
	{
		DescriptedParam *X=new DescriptedParam(x,szParamDescription);
		AddParam((BaseParam*)X);
		if (Logger!=NULL)Logger->LogParamRegistered((DescriptedAutomat*)this,X);
		return X;
	}
	
	//        
	virtual DescriptedAction* RegisterAction(uint32 z,xstring szActionDescription)
	{
		DescriptedAction *Z=new DescriptedAction(z,szActionDescription);
		AddAction((BaseAction*)Z);
		if (Logger!=NULL)Logger->LogActionRegistered((DescriptedAutomat*)this,(DescriptedAction*)Z);
		return Z;
	}

	
	//   -
	void virtual Run(BaseEvent *E)
	{
		if (Y==NULL) Y=RegisteredStates[0];
		if (Logger!=NULL)Logger->LogEventRaised((DescriptedAutomat*)	this,(DescriptedEvent*)E);
		DescriptedState Old_Y=*(DescriptedState*)Y;
		BaseRun(E);
		if (Logger!=NULL)Logger->LogStateChanged((DescriptedAutomat*)this,&Old_Y,(DescriptedState*)Y);
		if (Logger!=NULL)Logger->LogEventFinished((DescriptedAutomat*)this,(DescriptedEvent*)E);
	}

	//  n-      
	virtual bool x(uint32 n)
	{
		BaseParam *X=NULL;
		for(uint32 i=0;i<iRegisteredParamsNum;i++)
		{
			if (RegisteredParams[i]->x==n)
			{
				X=RegisteredParams[i];
				break;
			}
		}
		if (X==NULL)
		{
			throw "     ";
		}
		if (Logger!=NULL)Logger->LogParamCalcStarted((DescriptedAutomat*)this,(DescriptedParam*)X);
		bool b=Param(n);
		if (Logger!=NULL)Logger->LogParamCalcFinished((DescriptedAutomat*)this,(DescriptedParam*)X,b);
		return b;
	}

	// n-      
	virtual void z(uint32 n)
	{
		BaseAction *Z=NULL;
		for(uint32 i=0;i<iRegisteredActionsNum;i++)
		{
			if (RegisteredActions[i]->z==n)
			{
				Z=RegisteredActions[i];
				break;
			}
		}
		if (Z==NULL)
		{
			throw "     ";
		}
		if (Logger!=NULL) Logger->LogActionStarted((DescriptedAutomat*)this,(DescriptedAction*)Z);
		Action(n);
		if (Logger!=NULL) Logger->LogActionFinished((DescriptedAutomat*)this,(DescriptedAction*)Z);
	}
};
#endif