// Logger.h
// ,   
// "  ",  
//  ,  ,   
//     , 
//    .

#ifndef __Logger_h
#define __Logger_h

#include "Auto-Lib.h"
#include <stdio.h>
#include <windows.h>

// "  "
class FileLogger : public BaseLogger
{
private:
	
	FILE *fout;	// 
	uint32 n;	//

public:
	
	//,   -
	FileLogger(xstring szFileName)
	{
		fout=fopen(szFileName.c_str(),"w");
		fprintf(fout," \n{\n");
		n=1;
		fflush(fout);
	}
	
	//
	~FileLogger()
	{
		fprintf(fout,"}\n ");
		fclose(fout);
	}
	
	// 
	void Space()
	{
		for(uint32 i=0;i<n;i++)
		{
			fprintf(fout,"   ");
		}
		fflush(fout);
	}

	//  
	virtual LogString(xstring szComment)
	{
		Space();
		fprintf(fout,szComment.c_str());
		fprintf(fout,"\n");
		fflush(fout);
	}
	
	//  
	virtual LogAutomatCreated(DescriptedAutomat *A)
	{
		Space();
		fprintf(fout,"A%i(%s) \n",A->a,A->szAutomatDescription.c_str());
		fflush(fout);
	}

	//   
	virtual LogAutomatFinished(DescriptedAutomat *A)
	{
		Space();
		fprintf(fout,"A%i(%s)  \n",A->a,A->szAutomatDescription.c_str());
		fflush(fout);		
	}

	//  
	virtual LogStateRegistered(DescriptedAutomat *A,DescriptedState *Y)
	{

	}
	
	//  
	virtual LogEventRegistered(DescriptedAutomat *A,DescriptedEvent *Y)
	{

	}

	//   
	virtual LogParamRegistered(DescriptedAutomat *A,DescriptedParam *X)
	{

	}

	//   
	virtual LogActionRegistered(DescriptedAutomat *A,DescriptedAction *Z)
	{

	}
	
	//  
	virtual LogStateChanged(DescriptedAutomat *A, DescriptedState *Old_Y,DescriptedState *Y)
	{
		if ((A->a>=20)&&(Old_Y->y!=Y->y))
		{
			Space();
			fprintf(fout,"A%i(%s) y%i(%s)-->y%i(%s)\n",A->a,A->szAutomatDescription.c_str(),Old_Y->y,Old_Y->szStateDescription.c_str(),Y->y,Y->szStateDescription.c_str());
			fflush(fout);
		}
	}
	
	//   
	virtual LogEventRaised(DescriptedAutomat *A,DescriptedEvent *E)
	{
		Space();
		fprintf(fout,"A%i(%s)  e%i(%s)\n",A->a,A->szAutomatDescription.c_str(),E->e,E->szEventDescription.c_str());
		n++;
		fflush(fout);
	}
	
	//   
	virtual LogEventFinished(DescriptedAutomat *A,DescriptedEvent *E)
	{
		n--;
		Space();
		fprintf(fout,"A%i(%s)  e%i(%s)\n",A->a,A->szAutomatDescription.c_str(),E->e,E->szEventDescription.c_str());
		fflush(fout);
	}

	//    
	virtual LogParamCalcStarted(DescriptedAutomat *A, DescriptedParam *X)
	{
		Space();
		fprintf(fout,"A%i(%s)   x%i(%s)\n",A->a,A->szAutomatDescription.c_str(),X->x,X->szParamDescription.c_str());
		n++;
		fflush(fout);
	}

	//    
	virtual LogParamCalcFinished(DescriptedAutomat *A, DescriptedParam *X, bool x)
	{
		n--;
		Space();
		xstring rez;
		if (x) rez="True";
		else rez="False";
		fprintf(fout,"A%i(%s)  x%i(%s): [%s]\n",A->a,A->szAutomatDescription.c_str(),X->x,X->szParamDescription.c_str(),rez.c_str());
		fflush(fout);
	}

	//    
	virtual LogActionStarted(DescriptedAutomat *A, DescriptedAction *Z)
	{
		Space();
		fprintf(fout,"A%i(%s)   z%i(%s)\n",A->a,A->szAutomatDescription.c_str(),Z->z,Z->szActionDescription.c_str());
		n++;
		fflush(fout);
	}

	//    
	virtual LogActionFinished(DescriptedAutomat *A, DescriptedAction *Z)
	{
		n--;
		Space();
		fprintf(fout,"A%i(%s)  z%i(%s)\n",A->a,A->szAutomatDescription.c_str(),Z->z,Z->szActionDescription.c_str());
		fflush(fout);
	}
};
#endif