// Models.cpp
// ,   , , 
// ,    ,    
// .  .

#include "Models.h";

//   uint32   
int	get_uint32(uint8** parr)
{
	uint32 *x=(uint*)*parr;
	*parr+=sizeof(uint);
	return *x;
}
	
//   char   
char get_char(uint8** parr)
{
	char *x=(char*)*parr;
	*parr+=sizeof(char);
	return *x;
}

//   flt   
flt	get_flt(uint8** parr)
{
	flt *x=(flt*)*parr;
	*parr+=sizeof(flt);
	return *x;
}

//    
char *get_str(uint8 **parr)
{
	uint32 l=get_uint32(parr);
	char *s=new char[l+1];
	s[l]=0;
	for(uint32 i=0;i<l;i++) s[i]=get_char(parr);
	return s;
}

// - ''
TmLoaderAutomat::TmLoaderAutomat(TmModelAutomat *Model,uint32 a,  xstring szAutomatDescription,BaseLogger *Logger) : LoggedAutomat(a,szAutomatDescription,Logger)
{
	this->Model=Model;
	x7=false;
		
	RegisterState(0," ");
	RegisterState(1,"  ");
	RegisterState(2," ");
	RegisterState(3,"  ");
		
	RegisterEvent(4,"  ");
	RegisterEvent(5,"  ");
	RegisterEvent(6,"   ");
	
	RegisterParam(7,"  ");
	RegisterAction(8," ");
	RegisterAction(9," ");
}

//  A1 ''
void TmLoaderAutomat::Main()
{
	switch(y)
	{
	case 0:
		if (e==4)
		{
			z(8);
			y=1;
		}
		break;
	case 1:
		if (e==6 && x(7))
							
		{
			y=2;
		}
		if (e==6 && !x(7))
							
		{
			y=3;
		}
		if (e==5 && x(7))
						
		{
			z(9);
			y=0;
		}
		if (e==5 && !x(7))
							
		{
			y=0;
		}
		break;
	case 2:
		if (e==5)
		{
			z(9);
			y=0;
		}
		break;
	case 3:
		if (e==5)
		{
			y=0;
		}
			break;
	}
}

//     ''
bool TmLoaderAutomat::Param(uint32 n)
{
	switch(n)
	{
	case 7:
		return x7;
		break;
	}
}

//     ''
void TmLoaderAutomat::Action(uint32 n)
{
	switch(n)
	{
	case 8:
		load();
		x7=true;
		break;
	case 9:
		unload();
		x7=false;
		break;
	}
}

//  
void TmLoaderAutomat::load()
{
	uint8* arr;
	uint32 size;
	xstring realname=Model->ModelName+".mdl";
	FILE *inp=fopen(realname.c_str(),"rb");
	fseek(inp,0,SEEK_END);
	fpos_t pos;
	fgetpos(inp,&pos);
	fseek(inp,0,SEEK_SET);
	size=pos;
	arr=new uint8[size];
	fread(arr,sizeof(uint8),size,inp);
	fclose(inp);
	uint8* prearr=arr;
	char *crc=get_str(&arr);
	if (strcmp(crc,"MMFB"))
		throw "Cannot load model";
	delete[] crc;
	Model->Version=get_uint32(&arr);
	Model->TextureIndex=get_uint32(&arr);
	Model->LastTime=0;
	//  
	char *str=get_str(&arr);
	Model->Name=str;
	delete[] str;
	//  
	Model->PartCount=get_uint32(&arr);
	// -
	Model->BoundVertexCount=get_uint32(&arr);
	Model->BoundFacesCount=get_uint32(&arr);
	Model->BoundFaces=new TmFace[Model->BoundFacesCount];
	// 
	uint32 i;
    for(i=0;i<Model->BoundFacesCount;i++)
	{// i- 
		TmFace *Face=&Model->BoundFaces[i];
		Face->a=get_uint32(&arr);
		Face->b=get_uint32(&arr);
		Face->c=get_uint32(&arr);
	}// 
	Model->BoundVertices=new TxVector3f[Model->BoundVertexCount];
	// 
	for(i=0;i<Model->BoundVertexCount;i++)
	{// i- 
		TxVector3f *Vertex=&Model->BoundVertices[i];
		Vertex->x=get_flt(&arr);
		Vertex->y=get_flt(&arr);
		Vertex->z=get_flt(&arr);
	}// 
	// -
	Model->Parts=new TmPart[Model->PartCount];
	// 
	for(i=0;i<Model->PartCount;i++)
	{// i- 
		TmPart *Part=&Model->Parts[i];
		Part->LocalTime=0;
		Part->FramesCount=get_uint32(&arr);
		Part->GroupsCount=get_uint32(&arr);
		Part->VertexCount=get_uint32(&arr);
		Part->FacesCount=get_uint32(&arr);
		Part->Faces=new TmFace[Part->FacesCount];
		// 
		uint32 j;
		for(j=0;j<Part->FacesCount;j++)
		{// j- 
			TmFace *Face=&Part->Faces[j];
			Face->a=get_uint32(&arr);
			Face->b=get_uint32(&arr);
			Face->c=get_uint32(&arr);
		}// 
		//  
		Part->TmpFrame.Vertices=new TmVertex[Part->VertexCount];
		Part->CurrentFrame.Vertices=new TmVertex[Part->VertexCount];
		Part->Frames=new TmFrame[Part->FramesCount];
		// 
		for(j=0;j<Part->FramesCount;j++)
		{// j- 
			TmFrame *Frame=&Part->Frames[j];
			Frame->Vertices=new TmVertex[Part->VertexCount];
			// 
			for(uint32 k=0;k<Part->VertexCount;k++)
			{// k- 
				TmVertex *Vertex=&Frame->Vertices[k];
				Vertex->x=get_flt(&arr);
				Vertex->y=get_flt(&arr);
				Vertex->z=get_flt(&arr);
				Vertex->u=get_flt(&arr);
				Vertex->v=get_flt(&arr);
			}// 
		}// 
		// IdleGroup
		Part->CurrentGroup=&Part->IdleGroup;
		Part->NextGroup=&Part->IdleGroup;
		Part->AfterPrevTime=0;
		TmGroup *IdleGroup=&Part->IdleGroup;
		IdleGroup->GroupID=0;
		IdleGroup->GroupIndex=65535;
		IdleGroup->PreFrameCount=0;
		IdleGroup->LoopFrameCount=0;
		IdleGroup->PostFrameCount=get_uint32(&arr);
		IdleGroup->Frames=new TmFrame*[IdleGroup->PostFrameCount];
		IdleGroup->Time=new uint[IdleGroup->PostFrameCount];
		IdleGroup->PreTime=IdleGroup->LoopTime=IdleGroup->PostTime=0;
		IdleGroup->PreAndLoopTime=0;
		//   IdleGroup-  
		for(j=0;j<IdleGroup->PostFrameCount;j++)
		{//  j-  IdleGroup-  
			IdleGroup->Frames[j]=&Part->Frames[get_uint32(&arr)];
			uint32 time=get_uint32(&arr);
			IdleGroup->Time[j]=time;
			IdleGroup->PostTime+=time;
		}//   IdleGroup-  
		IdleGroup->AllTime=IdleGroup->PostTime;
		Part->PrevFrame=Part->IdleGroup.Frames[0];
		Part->NextFrameIndex=0;
		Part->AfterPrevTime=0;
		// IdleGroup
		Part->PrevFrame=IdleGroup->Frames[0];
		Part->Groups=new TmGroup[Part->GroupsCount];
		// 
		for(j=0;j<Part->GroupsCount;j++)
		{// j- 
			TmGroup *Group=&Part->Groups[j];
			Group->GroupID=get_uint32(&arr);
			Group->GroupIndex=j;
			Group->PreFrameCount=get_uint32(&arr);
			Group->LoopFrameCount=get_uint32(&arr);
			Group->PostFrameCount=get_uint32(&arr);
			Group->PreTime=Group->LoopTime=Group->PostTime=0;
			uint32 TotalFrameNum=Group->PreFrameCount+
						Group->LoopFrameCount+	
						Group->PostFrameCount;
			Group->Frames=new TmFrame*[TotalFrameNum];
			Group->Time=new uint[TotalFrameNum];
			//    
			for(uint32 k=0;k<TotalFrameNum;k++)
			{//  k-    
				Group->Frames[k]=&Part->Frames[get_uint32(&arr)];
				uint32 time=get_uint32(&arr);
				Group->Time[k]=time;
				if (k<Group->PreFrameCount) 
					Group->PreTime+=time;
				if ((k<Group->LoopFrameCount+Group->PreFrameCount)&&(k>=Group->PreFrameCount)) 
					Group->LoopTime+=time;
				if ((k<Group->PostFrameCount+Group->LoopFrameCount+Group->PreFrameCount)&&(k>=Group->LoopFrameCount+Group->PreFrameCount)) 
					Group->PostTime+=time;
			}//    
			Group->PreAndLoopTime=Group->PreTime+Group->LoopTime;
			Group->AllTime=Group->PreTime+Group->LoopTime+Group->PostTime;
		}// 
	}// 
	crc=get_str(&arr);
	if (strcmp(crc,"MMFE"))
		throw "Cannot load model";
	delete[] crc;
	delete[] prearr;
}

//  
void TmLoaderAutomat::unload()
{
	// -
	delete[] Model->BoundFaces;
	delete[] Model->BoundVertices;
	// -
	// 
	for(uint32 i=0;i<Model->PartCount;i++)
	{// i- 
		TmPart *Part=&Model->Parts[i];
		delete[] Part->Faces;
		//  
		delete[] Part->TmpFrame.Vertices;
		delete[] Part->CurrentFrame.Vertices;
		// 
	  uint32 j;
		for(j=0;j<Part->FramesCount;j++)
		{// j- 
			TmFrame *Frame=&Part->Frames[j];
			delete[] Frame->Vertices;
		}
		delete[] Part->Frames;
		// 
		// IdleGroup
		TmGroup *IdleGroup=&Part->IdleGroup;
		delete[] IdleGroup->Frames;
		delete[] IdleGroup->Time;
		// IdleGroup;
		// 
		for(j=0;j<Part->GroupsCount;j++)
		{// j- 
			TmGroup *Group=&Part->Groups[j];
			delete[] Group->Frames;
			delete[] Group->Time;
		}
		delete[] Part->Groups;
		// 		
	}
	delete[] Model->Parts;
	// 
}

// - ''
TmModelAutomat::TmModelAutomat(xstring ModelName,uint32 a, xstring szAutomatDescription,BaseLogger *Logger) : LoggedAutomat(a,szAutomatDescription,Logger)
{
	this->ModelName=ModelName;
	
	RegisterState(300000,"   ");
	RegisterState(0," - ");
	
	RegisterAction(0," ''");
	RegisterAction(1," ''  ,  ");
	RegisterAction(2," ''");
	RegisterAction(3,"  ''");
	RegisterAction(4," ''  ");
	RegisterAction(5,"  ''");	
	RegisterAction(6,"  ");
	RegisterAction(7,"    ''");

	RegisterEvent(6,"  ");
	RegisterEvent(7," ");
	RegisterEvent(8," ");

	RegisterParam(0," ");
	RegisterParam(1," - -1");
	RegisterParam(2," - -2");
	RegisterParam(3," -  ");
	RegisterParam(4," -  ");
	RegisterParam(5," -  ");
	RegisterParam(6," -  ");
	RegisterParam(7," -  ");
	RegisterParam(8," -  ");
	RegisterParam(9," -  ");
	RegisterParam(10," -  ");
	RegisterParam(11," -  ");
	RegisterParam(12," -  ");
	RegisterParam(13," -    ");
	RegisterParam(14," -    ");
	RegisterParam(15," - ");
}

//     A0 ''
bool TmModelAutomat::Param(uint32 n)
{
	TmModelEvent *ME=(TmModelEvent*)E;
	switch(n)
	{
	case 0:
		return ME->mode;
	case 1:
		return ME->flag&fire1;
	case 2:
		return ME->flag&fire2;
	case 3:
		return ME->flag&moveleft;
	case 4:
		return ME->flag&moveright;
	case 5:
		return ME->flag&moveup;
	case 6:
		return ME->flag&movedown;
	case 7:
		return ME->flag&movefwd;
	case 8:
		return ME->flag&moveback;
	case 9:
		return ME->flag&rotleft;
	case 10:
		return ME->flag&rotright;
	case 11:
		return ME->flag&rotup;
	case 12:
		return ME->flag&rotdown;
	case 13:
		return ME->flag&rotcw;
	case 14:
		return ME->flag&rotccw;
	case 15:
		return ME->flag&pain;
	}


}

//  A0 ''
void TmModelAutomat::Main()
{
	if (y==300000)
	{	
		if(e==6)
		{
			z(0);
			z(1);
			z(2);
			y=0;
			return;
		}
	}
	
	//  
	if (y!=300000)
	{
		if (e==7)
		{
			z(3);
			z(4);
			z(5);
			y=300000;
			return;
		}
		
		//       32768 
		if (e==8)
		{
			//   
			for(uint32 i=1;i<16;i++)
			{
				if (x(i) && x(0)) y|=(1<<(i-1));
				if (x(i) && !x(0)) y&=~(1<<(i-1));
			}
			
			//
			Y->y=y;
			DescriptedState *DS=(DescriptedState*)Y;
			DS->szStateDescription="[";
			for(uint8 j=0;j<15;j++)
			{
				if (y&(1<<j)) DS->szStateDescription+=Caption[j]+" ";
			}
			DS->szStateDescription+="]";
			
			z(7);
			//   
			for(int i=0;i<PartCount;i++)
			{
				A2[i]->run(0);
			}
			z(6);
		}
	}
}

//     A0 ''
void TmModelAutomat::Action(uint32 n)
{
	TmModelEvent *ME=(TmModelEvent*)E;
	switch(n)
	{
	case 0:
		createloader();
		break;
	case 1:
		load();
		break;
	case 2:
		createparts();
		break;
	case 3:
		destroyparts();
		break;
	case 4:
		unload();
		break;
	case 5:
		destroyloader();
		break;
	case 6:
		this->LastTime=ME->time;
		break;
	case 7:
		for(uint32 i=0;i<PartCount;i++)
		{
			A2[i]->DeltaTime=ME->time-LastTime;
		}
		break;
	}
}

// ''
void TmModelAutomat::createloader()
{
	A1=new TmLoaderAutomat(this,1,"",Logger);
}

//  ''
void TmModelAutomat::destroyloader()
{
	delete A1;
}

// ''
void TmModelAutomat::createparts()
{
  A2=new TmPartAutomat*[PartCount];
  for(uint32 i=0;i<PartCount;i++)
  {
    char str[50];
    itoa(i,str,10);
    A2[i]=new TmPartAutomat(&Parts[i],this,20+i,xstring("-")+str,Logger);
  }
}

//  ''
void TmModelAutomat::destroyparts()
{
  for(uint32 i=0;i<PartCount;i++)
  {
    delete A2[i];
  }
  delete A2;
}

//   ''
void TmModelAutomat::load()
{
	A1->run(4);
	A1->run(6);
	if (A1->Get_y()!=2)
	{
		throw "  ";
	}
}

//   ''
void TmModelAutomat::unload()
{
	A1->run(5);
}

// - ''
TmPartAutomat::TmPartAutomat(TmPart *Part, TmModelAutomat *Model, uint32 a, xstring szAutomatDescription, BaseLogger *Logger) : LoggedAutomat(a,szAutomatDescription,Logger)
{
	this->Part=Part;
	this->Model=Model;
	RegisterEvent(0," ");
  
	RegisterState(0," ");
	RegisterState(1,"    ");
	RegisterState(2," ");

	RegisterParam(0,"          ");
	RegisterParam(1,"  ");
	RegisterParam(2,"   ");
	RegisterParam(3,"     ");
	RegisterParam(4,"    ");
	RegisterParam(11,"      ");

	RegisterAction(5,"       ");
	RegisterAction(6,"       ");
	RegisterAction(7,"  ");
	RegisterAction(8,"       ");
	RegisterAction(9,"       ");
	RegisterAction(10,"         ");
}

//     'c'
void TmPartAutomat::Action(uint32 n)
{
	uint32 NewDeltaTime;
	switch(n)
	{
	case 5:
		CalculateFrame(true);
		break;
	case 6:
		InterpolateFrame(&Part->TmpFrame,Part->PrevFrame,Part->CurrentGroup->Frames[Part->NextFrameIndex],Part->CurrentGroup->Time[Part->NextFrameIndex],Part->AfterPrevTime,Part->VertexCount);
		Part->PrevFrame=&Part->TmpFrame;
		Part->CurrentGroup=Part->NextGroup;
		Part->LocalTime=0;
		Part->AfterPrevTime=0;
		Part->NextFrameIndex=0;
		break;
	case 7:
		Part->NextGroup=GetNextGroup();
		break;
	case 8:
		CalculateFrame(false);
		break;
	case 9:
		NewDeltaTime=/*Model->*/DeltaTime-(Part->CurrentGroup->AllTime-Part->LocalTime);
		Part->NextFrameIndex=0;
		Part->LocalTime=0;
		Part->AfterPrevTime=0;
		Part->PrevFrame=Part->CurrentGroup->Frames[Part->CurrentGroup->PreFrameCount+Part->CurrentGroup->LoopFrameCount+Part->CurrentGroup->PostFrameCount-1];
		Part->CurrentGroup=Part->NextGroup;
		DeltaTime=NewDeltaTime;
		break;
	case 10:
		NewDeltaTime=/*Model->*/DeltaTime-(Part->CurrentGroup->PreAndLoopTime-Part->LocalTime);
		Part->NextFrameIndex=0;
		Part->LocalTime=0;
		Part->AfterPrevTime=0;
		Part->PrevFrame=Part->CurrentGroup->Frames[Part->CurrentGroup->PreFrameCount+Part->CurrentGroup->LoopFrameCount-1];
		Part->CurrentGroup=Part->NextGroup;
		DeltaTime=NewDeltaTime;
		break;
	}
}

//     ''
bool TmPartAutomat::Param(uint32 n)
{
	switch(n)
	{
	case 0:
		return Part->LocalTime+/*Model->*/DeltaTime<Part->CurrentGroup->PreAndLoopTime;
	case 1:
		return Part->NextGroup!=Part->CurrentGroup;
	case 2:
		return Part->NextGroup->GroupIndex>Part->CurrentGroup->GroupIndex;
	case 3:
		return Part->LocalTime+/*Model->*/DeltaTime<Part->CurrentGroup->AllTime;
	case 4:
		return Part->LocalTime<=Part->CurrentGroup->PreAndLoopTime;
	case 11:
		//return (Part->CurrentGroup->LoopFrameCount==0)&&(Model->DeltaTime-(Part->CurrentGroup->AllTime-Part->LocalTime)>Part->CurrentGroup->PreTime);
		return (Part->LocalTime+DeltaTime<Part->CurrentGroup->AllTime)||(Part->NextGroup->LoopFrameCount==0)&&(/*Model->*/DeltaTime-(Part->CurrentGroup->AllTime-Part->LocalTime)>Part->NextGroup->PreTime);
	}
}

//     
TmGroup* TmPartAutomat::GetNextGroup()
{
	TmGroup *NextGroup=&Part->IdleGroup;
	uint32 state=Model->y;
	if (state&(fire1|fire2)) 
		state|=fire;
	if (state&(moveleft|moveright|moveup|movedown|movefwd|moveback)) 
		state|=move;
	if (state&(rotleft|rotright|rotup|rotdown|rotcw|rotccw))
		state|=rot;
	for(int i=0;i<Part->GroupsCount;i++)
	{
		if (Part->Groups[i].GroupID&state)
		{
			NextGroup=&Part->Groups[i];
			break;
		}
	}
	return NextGroup;
}

//  ''
void TmPartAutomat::Main()
{
	switch(y)
	{
	case 0:
		if (x(4) && x(1) && x(3))
		{
			z(8);
			z(7);
			y=1;
		} else

		if (x(3) && ((x(2) && !x(4) && x(1)) || (!x(1) && x(11))))
		{
			z(8);
			z(7);
			y=0;
		} else
	
		if (x(3) && ((!x(1) && !x(11)) || (!x(2) && !x(4) && x(1))))
		{
			z(8);
			z(7);			
			z(6);
			y=2;
		} else

		if (x(4) && x(1) && x(11) && !x(3))
		{
			z(9);
			z(8);
			z(7);
			y=1;
		} else

		if(x(2) && !x(4) && x(1) && x(11) && !x(3))
		{
			z(9);
			z(8);
			z(7);
			y=0;
		} else
		
		if (!x(1) && !x(11) && !x(3))
		{
			z(9);
			z(8);
			z(7);
			y=2;
		} else
		
		if (!x(1) && x(11) && !x(3))
		{
			z(9);
			z(8);
			z(7);
			y=0;
		} else

	case 1:
		if (x(1) &&((x(4) && x(2) && x(3))||x(0)))
		{
			z(8);
			z(7);
			y=1;
		} else

		if (!x(1) && ((x(2) && x(3))||x(0)))
		{
			z(8);
			z(7);
			y=2;
		} else
		
	
		if(!x(4) && x(1) && !x(0) && x(2) && x(3))
		{
			z(8);
			z(7);
			y=0;
		} else
		
		if ((!x(1) || x(4)) && !x(0) && x(2) && !x(3))
		{
			z(9);
			z(5);
			z(7);
			y=2;
		} else
		
		if(!x(4) && x(1) && !x(0) && x(2) && !x(3))
		{
			z(9);
			z(5);
			z(7);
			y=0;
		
		} else
		
		if (x(4) && x(1) && !x(0) && !x(2))
		{
			z(10);
			z(5);
			z(7);
			y=1;
		} else
	
		if (!x(4) && x(1) && !x(0) && !x(2))
		{
			z(10);
			z(5);
			z(7);
			z(6);
			y=0;
		} else
	
		if (!x(1) && !x(0) && !x(2))
		{
			z(10);
			z(5);
			z(7);
			y=2;
		}
		break;

	case 2:
		z(5);
		z(7);
		
		if (x(4) && x(1))
		{
			y=1;
		} else
	
		if(x(2) && !x(4) && x(1))
		{
			y=0;
		} else
		
		if (!x(2) && !x(4) && x(1))
		{
			z(6);
			y=0;
		} else
	
		if (!x(1))
		{
			y=2;
		}
		break;
	}
}

//    
void TmPartAutomat::IncNFI(bool DefState)
{
   Part->NextFrameIndex++;
   if (Part->NextFrameIndex==Part->CurrentGroup->PreFrameCount+Part->CurrentGroup->LoopFrameCount+Part->CurrentGroup->PostFrameCount)
   {
     Part->NextFrameIndex=0;
   }
   if ((Part->CurrentGroup->LoopFrameCount!=0)&&(DefState)&&(Part->NextFrameIndex==Part->CurrentGroup->PreFrameCount+Part->CurrentGroup->LoopFrameCount))
   {
     Part->NextFrameIndex=Part->CurrentGroup->PreFrameCount;
   }
}

//    
void TmPartAutomat::InterpolateFrame(TmFrame *dest,TmFrame *s1,TmFrame *s2,uint32 alltime,uint32 delta, uint32 pn)
{
	for(uint32 i=0;i<pn;i++)
	{
		dest->Vertices[i].x=s1->Vertices[i].x+(flt)(s2->Vertices[i].x-s1->Vertices[i].x)*((flt)delta)/((flt)alltime);
		dest->Vertices[i].y=s1->Vertices[i].y+(flt)(s2->Vertices[i].y-s1->Vertices[i].y)*((flt)delta)/((flt)alltime);
		dest->Vertices[i].z=s1->Vertices[i].z+(flt)(s2->Vertices[i].z-s1->Vertices[i].z)*((flt)delta)/((flt)alltime);
		dest->Vertices[i].u=s1->Vertices[i].u+(flt)(s2->Vertices[i].u-s1->Vertices[i].u)*((flt)delta)/((flt)alltime);
		dest->Vertices[i].v=s1->Vertices[i].v+(flt)(s2->Vertices[i].v-s1->Vertices[i].v)*((flt)delta)/((flt)alltime);
	}
}

//   
void TmPartAutomat::CalculateFrame(bool DefState)
{
	uint32 deltatime=this->DeltaTime;
	
	if (Part->AfterPrevTime+deltatime>Part->CurrentGroup->Time[Part->NextFrameIndex])
    {
      	Part->PrevFrame=Part->CurrentGroup->Frames[Part->NextFrameIndex];
		uint32 stp=Part->CurrentGroup->Time[Part->NextFrameIndex]-Part->AfterPrevTime;    
		deltatime-=stp;
		IncNFI(DefState);
		while(deltatime>Part->CurrentGroup->Time[Part->NextFrameIndex])
		{
			deltatime-=Part->CurrentGroup->Time[Part->NextFrameIndex];
		  	Part->PrevFrame=Part->CurrentGroup->Frames[Part->NextFrameIndex];
			IncNFI(DefState);
  		}
  		Part->LocalTime=deltatime;
		Part->AfterPrevTime=deltatime;
		for(int i=0;i<(int)Part->NextFrameIndex;i++)
  		{
  			Part->LocalTime+=Part->CurrentGroup->Time[i];
  		}
    } else
    {
		Part->AfterPrevTime+=deltatime;
		Part->LocalTime+=deltatime;
    }
}

//  '   A0 '''
TmModelEvent::TmModelEvent(uint32 flag,uint32 time, bool mode,uint32 x,xstring szEventDescription) : DescriptedEvent(x,szEventDescription)
{
  this->mode=mode;
  this->flag=flag;
  this->time=time;
}
