#include <windows.h>
#include <stdio.h>
#include <GL/gl.h>
#include <GL/glu.h>
#include <GL/glaux.h>
#include "vars.h"
#include "resource.h"


LRESULT CALLBACK WndProc(HWND, UINT, WPARAM, LPARAM);
BOOL CALLBACK ControlDiaProc(HWND, UINT, WPARAM, LPARAM);

char szWinName[] = "Models Display";
char szWinTitle[] = "Models Display";

HWND hPColorDlg;
void display()
{
	glClear( GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT );	
	event->szEventDescription="  ";
	event->time=GetTickCount()-StartTickCount;
	A0->Run((BaseEvent*)event);
   	glBegin(GL_TRIANGLES);
	int maxp=A0->PartCount;
	for(int p=0;p<maxp;p++)
	{
		TmPartAutomat *A2=A0->A2[p];
		TmPart *Part=A2->Part;
		A2->InterpolateFrame(&(Part->CurrentFrame),Part->PrevFrame,Part->CurrentGroup->Frames[Part->NextFrameIndex],Part->CurrentGroup->Time[Part->NextFrameIndex],Part->AfterPrevTime,Part->VertexCount);
		int maxf=Part->FacesCount;
		for(int f=0;f<maxf;f++)
		{
			TmFace *Face=&Part->Faces[f];
			TmFace fc=*Face;
			TmVertex a=Part->CurrentFrame.Vertices[Face->a];
			TmVertex b=Part->CurrentFrame.Vertices[Face->b];
			TmVertex c=Part->CurrentFrame.Vertices[Face->c];
			glVertex3f(a.x,a.y,a.z);
			glVertex3f(b.x,b.y,b.z);
			glVertex3f(c.x,c.y,c.z);
		}
	}
	glEnd();
	auxSwapBuffers();
	



	SwapBuffers(wglGetCurrentDC());
}

void resize(int width,int height)
{
	glViewport(0,0,width,height);
	glMatrixMode( GL_PROJECTION );
	glLoadIdentity();
	glOrtho(-120,120, -120,120,-170,170);   
	gluLookAt( 10,70,20, 0,0,0, 0,0,1 );
	glMatrixMode( GL_MODELVIEW );
}    

int SetWindowPixelFormat()
{
	int m_GLPixelIndex;
	PIXELFORMATDESCRIPTOR pfd;
    pfd.nSize       = sizeof(PIXELFORMATDESCRIPTOR);
    pfd.nVersion    = 1;
    pfd.dwFlags   = PFD_DRAW_TO_WINDOW | 
                    PFD_SUPPORT_OPENGL | 
                    PFD_DOUBLEBUFFER;
    pfd.iPixelType     = PFD_TYPE_RGBA;
    pfd.cColorBits     = 32;
    pfd.cRedBits       = 8;
    pfd.cRedShift      = 16;
    pfd.cGreenBits     = 8;
    pfd.cGreenShift    = 8;
    pfd.cBlueBits      = 8;
    pfd.cBlueShift     = 0;
    pfd.cAlphaBits     = 0;
    pfd.cAlphaShift    = 0;
    pfd.cAccumBits     = 64;    
    pfd.cAccumRedBits  = 16;
    pfd.cAccumGreenBits   = 16;
    pfd.cAccumBlueBits    = 16;
    pfd.cAccumAlphaBits   = 0;
    pfd.cDepthBits        = 32;
    pfd.cStencilBits      = 8;
    pfd.cAuxBuffers       = 0;
    pfd.iLayerType        = PFD_MAIN_PLANE;
    pfd.bReserved         = 0;
    pfd.dwLayerMask       = 0;
    pfd.dwVisibleMask     = 0;
    pfd.dwDamageMask      = 0;
    m_GLPixelIndex = ChoosePixelFormat( hDC, &pfd);
    if(m_GLPixelIndex==0)
    {
     m_GLPixelIndex = 1;    
     if(DescribePixelFormat(hDC,m_GLPixelIndex,sizeof(PIXELFORMATDESCRIPTOR),&pfd)==0)
       return 0;
    }
    if (SetPixelFormat( hDC, m_GLPixelIndex, &pfd)==FALSE)
        return 0;
    return 1;
}

void Begin()
{
	event=new TmModelEvent(0,0,true,0," ");
	event->e=8;
	event->mode=false;
	event->flag=0;
	StartTickCount=GetTickCount();
	FileLogger *fl=new FileLogger("models2.log");
	A0=new TmModelAutomat("cube",0,"",fl);
	A0->run(6);
}

void End()
{
	A0->run(7);
	delete A0;
	delete event;
	delete fl;
}

int WINAPI WinMain(HINSTANCE hInst, HINSTANCE hPreInst,
				   LPSTR lpCmdLine, int nCmdShow)	
{
	MSG msg;
	WNDCLASS wcl;
	wcl.hInstance=hInst;
	wcl.lpszClassName = "OpenGLWinClass";
	wcl.lpfnWndProc = WndProc;
	wcl.style = CS_OWNDC | CS_HREDRAW | CS_VREDRAW;
	wcl.hIcon = NULL;
	wcl.hCursor = LoadCursor(NULL,IDC_ARROW);
	wcl.lpszMenuName = NULL;
	wcl.cbClsExtra = 0;
	wcl.cbWndExtra = 0;
	wcl.hbrBackground = (HBRUSH)GetStockObject(WHITE_BRUSH);
	RegisterClass(&wcl);
	hWnd = CreateWindow(
	"OpenGLWinClass", 
	" ", 
	WS_OVERLAPPEDWINDOW | WS_CLIPCHILDREN | WS_CLIPSIBLINGS,
	200,150,400,420,HWND_DESKTOP, NULL,hInst, NULL);
	ShowWindow(hWnd,nCmdShow);
	UpdateWindow(hWnd);
	while(1)
	{
		while( PeekMessage(&msg,NULL,0,0,PM_NOREMOVE) ) 
		if(GetMessage(&msg,NULL,0,0))
		{ 
			TranslateMessage(&msg);
			DispatchMessage(&msg);
		}
		else	return 0;
		display();
	}	
	return 0;
}

BOOL CALLBACK ControlDiaProc(HWND hDlg, UINT messg, 
			 WPARAM wParam, LPARAM lParam)
{
	HINSTANCE hInst;
	HWND parentWnd;
	TmModelEvent *e;
	xstring desc;
	switch (messg)
	{
    case WM_INITDIALOG: 
		hInst = (HINSTANCE)GetModuleHandle(NULL);
		return TRUE; 

	case WM_COMMAND:
		switch (LOWORD(wParam))
		{
		case IDC_CHECK2:
			bfire=!bfire;
			if (bfire) desc=" ";
			else desc=" ";
			e=new TmModelEvent(fire1,GetTickCount()-StartTickCount,bfire,8,desc);
			A0->Run(e);
			delete e;
			break;
		case IDC_CHECK3:
			bmove=!bmove;
			if (bmove) desc=" ";
			else desc=" ";
			e=new TmModelEvent(movefwd,GetTickCount()-StartTickCount,bmove,8,desc);
			A0->Run(e);
			delete e;
			break;
		default:
			return FALSE;
		}
		break;
		
	default:
		return FALSE;
	}

	return TRUE;
}

LRESULT CALLBACK WndProc(HWND hWnd, UINT messg,
			 WPARAM wParam, LPARAM lParam)
{
	float pos[4] = {100,100,100,1};
	float dir[3] = {-1,-1,-1};
	PAINTSTRUCT ps;

	switch (messg)
	{
	case WM_CREATE:
		hPColorDlg = CreateDialog((HINSTANCE)GetModuleHandle(NULL),
			MAKEINTRESOURCE(IDD_DIALOGBAR), hWnd, (DLGPROC)ControlDiaProc);
		hDC = GetDC(hWnd); 
		SetWindowPixelFormat(); 
		hGLRC = wglCreateContext(hDC);
		wglMakeCurrent(hDC, hGLRC);
		glEnable(GL_ALPHA_TEST);
		glEnable(GL_DEPTH_TEST);
		glEnable(GL_COLOR_MATERIAL);
		glEnable(GL_LIGHTING);
		glEnable(GL_LIGHT0);
		glEnable(GL_BLEND);
		glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
		glLightfv(GL_LIGHT0, GL_POSITION, pos);
		glLightfv(GL_LIGHT0, GL_SPOT_DIRECTION, dir);
		Begin();
	break;

	case WM_SIZE:
		resize( LOWORD(lParam), HIWORD(lParam) );
		break;

	case WM_COMMAND:
		switch (LOWORD(wParam))
		{
		default:
			break;
		}
		InvalidateRect(hWnd, NULL, TRUE);
		break;

	case WM_PAINT:
		BeginPaint(hWnd, &ps);
        display();
        EndPaint(hWnd, &ps);
		break;

	case WM_DESTROY:
		DestroyWindow(hPColorDlg);
		if (hGLRC) 
        {
            wglMakeCurrent(NULL, NULL);
            wglDeleteContext(hGLRC);
        }
        ReleaseDC(hWnd, hDC);
		End();
		PostQuitMessage(0);
		break;

	default:
		return (DefWindowProc(hWnd, messg, wParam, lParam));
	}
	return (0);
}